update.sh 47 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037
  1. #!/usr/bin/env bash
  2. ############## Begin Function Section ##############
  3. check_online_status() {
  4. CHECK_ONLINE_DOMAINS=('https://github.com' 'https://hub.docker.com')
  5. for domain in "${CHECK_ONLINE_DOMAINS[@]}"; do
  6. if timeout 6 curl --head --silent --output /dev/null ${domain}; then
  7. return 0
  8. fi
  9. done
  10. return 1
  11. }
  12. prefetch_images() {
  13. [[ -z ${BRANCH} ]] && { echo -e "\e[33m\nUnknown branch...\e[0m"; exit 1; }
  14. git fetch origin #${BRANCH}
  15. while read image; do
  16. if [[ "${image}" == "robbertkl/ipv6nat" ]]; then
  17. if ! grep -qi "ipv6nat-mailcow" docker-compose.yml || grep -qi "enable_ipv6: false" docker-compose.yml; then
  18. continue
  19. fi
  20. fi
  21. RET_C=0
  22. until docker pull ${image}; do
  23. RET_C=$((RET_C + 1))
  24. echo -e "\e[33m\nError pulling $image, retrying...\e[0m"
  25. [ ${RET_C} -gt 3 ] && { echo -e "\e[31m\nToo many failed retries, exiting\e[0m"; exit 1; }
  26. sleep 1
  27. done
  28. done < <(git show origin/${BRANCH}:docker-compose.yml | grep "image:" | awk '{ gsub("image:","", $3); print $2 }')
  29. }
  30. docker_garbage() {
  31. SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
  32. IMGS_TO_DELETE=()
  33. declare -A IMAGES_INFO
  34. COMPOSE_IMAGES=($(grep -oP "image: \Kmailcow.+" "${SCRIPT_DIR}/docker-compose.yml"))
  35. for existing_image in $(docker images --format "{{.ID}}:{{.Repository}}:{{.Tag}}" | grep 'mailcow/'); do
  36. ID=$(echo $existing_image | cut -d ':' -f 1)
  37. REPOSITORY=$(echo $existing_image | cut -d ':' -f 2)
  38. TAG=$(echo $existing_image | cut -d ':' -f 3)
  39. if [[ " ${COMPOSE_IMAGES[@]} " =~ " ${REPOSITORY}:${TAG} " ]]; then
  40. continue
  41. else
  42. IMGS_TO_DELETE+=("$ID")
  43. IMAGES_INFO["$ID"]="$REPOSITORY:$TAG"
  44. fi
  45. done
  46. if [[ ! -z ${IMGS_TO_DELETE[*]} ]]; then
  47. echo "The following unused mailcow images were found:"
  48. for id in "${IMGS_TO_DELETE[@]}"; do
  49. echo " ${IMAGES_INFO[$id]} ($id)"
  50. done
  51. if [ ! $FORCE ]; then
  52. read -r -p "Do you want to delete them to free up some space? [y/N] " response
  53. if [[ "$response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  54. docker rmi ${IMGS_TO_DELETE[*]}
  55. else
  56. echo "OK, skipped."
  57. fi
  58. else
  59. echo "Running in forced mode! Force removing old mailcow images..."
  60. docker rmi ${IMGS_TO_DELETE[*]}
  61. fi
  62. echo -e "\e[32mFurther cleanup...\e[0m"
  63. echo "If you want to cleanup further garbage collected by Docker, please make sure all containers are up and running before cleaning your system by executing \"docker system prune\""
  64. fi
  65. }
  66. in_array() {
  67. local e match="$1"
  68. shift
  69. for e; do [[ "$e" == "$match" ]] && return 0; done
  70. return 1
  71. }
  72. migrate_docker_nat() {
  73. NAT_CONFIG='{"ipv6":true,"fixed-cidr-v6":"fd00:dead:beef:c0::/80","experimental":true,"ip6tables":true}'
  74. # Min Docker version
  75. DOCKERV_REQ=20.10.2
  76. # Current Docker version
  77. DOCKERV_CUR=$(docker version -f '{{.Server.Version}}')
  78. if grep -qi "ipv6nat-mailcow" docker-compose.yml && grep -qi "enable_ipv6: true" docker-compose.yml; then
  79. echo -e "\e[32mNative IPv6 implementation available.\e[0m"
  80. echo "This will enable experimental features in the Docker daemon and configure Docker to do the IPv6 NATing instead of ipv6nat-mailcow."
  81. echo '!!! This step is recommended !!!'
  82. echo "mailcow will try to roll back the changes if starting Docker fails after modifying the daemon.json configuration file."
  83. read -r -p "Should we try to enable the native IPv6 implementation in Docker now (recommended)? [y/N] " dockernatresponse
  84. if [[ ! "${dockernatresponse}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  85. echo "OK, skipping this step."
  86. return 0
  87. fi
  88. fi
  89. # Sort versions and check if we are running a newer or equal version to req
  90. if [ $(printf "${DOCKERV_REQ}\n${DOCKERV_CUR}" | sort -V | tail -n1) == "${DOCKERV_CUR}" ]; then
  91. # If Dockerd daemon json exists
  92. if [ -s /etc/docker/daemon.json ]; then
  93. IFS=',' read -r -a dockerconfig <<< $(cat /etc/docker/daemon.json | tr -cd '[:alnum:],')
  94. if ! in_array ipv6true "${dockerconfig[@]}" || \
  95. ! in_array experimentaltrue "${dockerconfig[@]}" || \
  96. ! in_array ip6tablestrue "${dockerconfig[@]}" || \
  97. ! grep -qi "fixed-cidr-v6" /etc/docker/daemon.json; then
  98. echo -e "\e[33mWarning:\e[0m You seem to have modified the /etc/docker/daemon.json configuration by yourself and not fully/correctly activated the native IPv6 NAT implementation."
  99. echo "You will need to merge your existing configuration manually or fix/delete the existing daemon.json configuration before trying the update process again."
  100. echo -e "Please merge the following content and restart the Docker daemon:\n"
  101. echo ${NAT_CONFIG}
  102. return 1
  103. fi
  104. else
  105. echo "Working on IPv6 NAT, please wait..."
  106. echo ${NAT_CONFIG} > /etc/docker/daemon.json
  107. ip6tables -F -t nat
  108. [[ -e /etc/alpine-release ]] && rc-service docker restart || systemctl restart docker.service
  109. if [[ $? -ne 0 ]]; then
  110. echo -e "\e[31mError:\e[0m Failed to activate IPv6 NAT! Reverting and exiting."
  111. rm /etc/docker/daemon.json
  112. if [[ -e /etc/alpine-release ]]; then
  113. rc-service docker restart
  114. else
  115. systemctl reset-failed docker.service
  116. systemctl restart docker.service
  117. fi
  118. return 1
  119. fi
  120. fi
  121. # Removing legacy container
  122. sed -i '/ipv6nat-mailcow:$/,/^$/d' docker-compose.yml
  123. if [ -s docker-compose.override.yml ]; then
  124. sed -i '/ipv6nat-mailcow:$/,/^$/d' docker-compose.override.yml
  125. if [[ "$(cat docker-compose.override.yml | sed '/^\s*$/d' | wc -l)" == "2" ]]; then
  126. mv docker-compose.override.yml docker-compose.override.yml_backup
  127. fi
  128. fi
  129. echo -e "\e[32mGreat! \e[0mNative IPv6 NAT is active.\e[0m"
  130. else
  131. echo -e "\e[31mPlease upgrade Docker to version ${DOCKERV_REQ} or above.\e[0m"
  132. return 0
  133. fi
  134. }
  135. remove_obsolete_nginx_ports() {
  136. # Removing obsolete docker-compose.override.yml
  137. for override in docker-compose.override.yml docker-compose.override.yaml; do
  138. if [ -s $override ] ; then
  139. if cat $override | grep nginx-mailcow > /dev/null 2>&1; then
  140. if cat $override | grep -E '(\[::])' > /dev/null 2>&1; then
  141. if cat $override | grep -w 80:80 > /dev/null 2>&1 && cat $override | grep -w 443:443 > /dev/null 2>&1 ; then
  142. echo -e "\e[33mBacking up ${override} to preserve custom changes...\e[0m"
  143. echo -e "\e[33m!!! Manual Merge needed (if other overrides are set) !!!\e[0m"
  144. sleep 3
  145. cp $override ${override}_backup
  146. sed -i '/nginx-mailcow:$/,/^$/d' $override
  147. echo -e "\e[33mRemoved obsolete NGINX IPv6 Bind from original override File.\e[0m"
  148. if [[ "$(cat $override | sed '/^\s*$/d' | wc -l)" == "2" ]]; then
  149. mv $override ${override}_empty
  150. echo -e "\e[31m${override} is empty. Renamed it to ensure mailcow is startable.\e[0m"
  151. fi
  152. fi
  153. fi
  154. fi
  155. fi
  156. done
  157. }
  158. detect_docker_compose_command(){
  159. if ! [[ "${DOCKER_COMPOSE_VERSION}" =~ ^(native|standalone)$ ]]; then
  160. if docker compose > /dev/null 2>&1; then
  161. if docker compose version --short | grep "2." > /dev/null 2>&1; then
  162. DOCKER_COMPOSE_VERSION=native
  163. COMPOSE_COMMAND="docker compose"
  164. echo -e "\e[33mFound Docker Compose Plugin (native).\e[0m"
  165. echo -e "\e[33mSetting the DOCKER_COMPOSE_VERSION Variable to native\e[0m"
  166. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=native/' $SCRIPT_DIR/mailcow.conf
  167. sleep 2
  168. echo -e "\e[33mNotice: You'll have to update this Compose Version via your Package Manager manually!\e[0m"
  169. else
  170. echo -e "\e[31mCannot find Docker Compose with a Version Higher than 2.X.X.\e[0m"
  171. echo -e "\e[31mPlease update/install it manually regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  172. exit 1
  173. fi
  174. elif docker-compose > /dev/null 2>&1; then
  175. if ! [[ $(alias docker-compose 2> /dev/null) ]] ; then
  176. if docker-compose version --short | grep "^2." > /dev/null 2>&1; then
  177. DOCKER_COMPOSE_VERSION=standalone
  178. COMPOSE_COMMAND="docker-compose"
  179. echo -e "\e[33mFound Docker Compose Standalone.\e[0m"
  180. echo -e "\e[33mSetting the DOCKER_COMPOSE_VERSION Variable to standalone\e[0m"
  181. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=standalone/' $SCRIPT_DIR/mailcow.conf
  182. sleep 2
  183. echo -e "\e[33mNotice: For an automatic update of docker-compose please use the update_compose.sh scripts located at the helper-scripts folder.\e[0m"
  184. else
  185. echo -e "\e[31mCannot find Docker Compose with a Version Higher than 2.X.X.\e[0m"
  186. echo -e "\e[31mPlease update/install regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  187. exit 1
  188. fi
  189. fi
  190. else
  191. echo -e "\e[31mCannot find Docker Compose.\e[0m"
  192. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  193. exit 1
  194. fi
  195. elif [ "${DOCKER_COMPOSE_VERSION}" == "native" ]; then
  196. COMPOSE_COMMAND="docker compose"
  197. # Check if Native Compose works and has not been deleted
  198. if ! $COMPOSE_COMMAND > /dev/null 2>&1; then
  199. # IF it not exists/work anymore try the other command
  200. COMPOSE_COMMAND="docker-compose"
  201. if ! $COMPOSE_COMMAND > /dev/null 2>&1 || ! $COMPOSE_COMMAND --version | grep "^2." > /dev/null 2>&1; then
  202. # IF it cannot find Standalone in > 2.X, then script stops
  203. echo -e "\e[31mCannot find Docker Compose or the Version is lower then 2.X.X.\e[0m"
  204. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  205. exit 1
  206. fi
  207. # If it finds the standalone Plugin it will use this instead and change the mailcow.conf Variable accordingly
  208. echo -e "\e[31mFound different Docker Compose Version then declared in mailcow.conf!\e[0m"
  209. echo -e "\e[31mSetting the DOCKER_COMPOSE_VERSION Variable from native to standalone\e[0m"
  210. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=standalone/' $SCRIPT_DIR/mailcow.conf
  211. sleep 2
  212. fi
  213. elif [ "${DOCKER_COMPOSE_VERSION}" == "standalone" ]; then
  214. COMPOSE_COMMAND="docker-compose"
  215. # Check if Standalone Compose works and has not been deleted
  216. if ! $COMPOSE_COMMAND > /dev/null 2>&1 && ! $COMPOSE_COMMAND --version > /dev/null 2>&1 | grep "^2." > /dev/null 2>&1; then
  217. # IF it not exists/work anymore try the other command
  218. COMPOSE_COMMAND="docker compose"
  219. if ! $COMPOSE_COMMAND > /dev/null 2>&1; then
  220. # IF it cannot find Native in > 2.X, then script stops
  221. echo -e "\e[31mCannot find Docker Compose.\e[0m"
  222. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  223. exit 1
  224. fi
  225. # If it finds the native Plugin it will use this instead and change the mailcow.conf Variable accordingly
  226. echo -e "\e[31mFound different Docker Compose Version then declared in mailcow.conf!\e[0m"
  227. echo -e "\e[31mSetting the DOCKER_COMPOSE_VERSION Variable from standalone to native\e[0m"
  228. sed -i 's/^DOCKER_COMPOSE_VERSION=.*/DOCKER_COMPOSE_VERSION=native/' $SCRIPT_DIR/mailcow.conf
  229. sleep 2
  230. fi
  231. fi
  232. }
  233. detect_bad_asn() {
  234. echo -e "\e[33mDetecting if your IP is listed on Spamhaus Bad ASN List...\e[0m"
  235. response=$(curl --connect-timeout 15 --max-time 30 -s -o /dev/null -w "%{http_code}" "https://asn-check.mailcow.email")
  236. if [ "$response" -eq 503 ]; then
  237. if [ -z "$SPAMHAUS_DQS_KEY" ]; then
  238. echo -e "\e[33mYour server's public IP uses an AS that is blocked by Spamhaus to use their DNS public blocklists for Postfix.\e[0m"
  239. echo -e "\e[33mmailcow did not detected a value for the variable SPAMHAUS_DQS_KEY inside mailcow.conf!\e[0m"
  240. sleep 2
  241. echo ""
  242. echo -e "\e[33mTo use the Spamhaus DNS Blocklists again, you will need to create a FREE account for their Data Query Service (DQS) at: https://www.spamhaus.com/free-trial/sign-up-for-a-free-data-query-service-account\e[0m"
  243. echo -e "\e[33mOnce done, enter your DQS API key in mailcow.conf and mailcow will do the rest for you!\e[0m"
  244. echo ""
  245. sleep 2
  246. else
  247. echo -e "\e[33mYour server's public IP uses an AS that is blocked by Spamhaus to use their DNS public blocklists for Postfix.\e[0m"
  248. echo -e "\e[32mmailcow detected a Value for the variable SPAMHAUS_DQS_KEY inside mailcow.conf. Postfix will use DQS with the given API key...\e[0m"
  249. fi
  250. elif [ "$response" -eq 200 ]; then
  251. echo -e "\e[33mCheck completed! Your IP is \e[32mclean\e[0m"
  252. elif [ "$response" -eq 429 ]; then
  253. echo -e "\e[33mCheck completed! \e[31mYour IP seems to be rate limited on the ASN Check service... please try again later!\e[0m"
  254. else
  255. echo -e "\e[31mCheck failed! \e[0mMaybe a DNS or Network problem?\e[0m"
  256. fi
  257. }
  258. ############## End Function Section ##############
  259. # Check permissions
  260. if [ "$(id -u)" -ne "0" ]; then
  261. echo "You need to be root"
  262. exit 1
  263. fi
  264. SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
  265. # Run pre-update-hook
  266. if [ -f "${SCRIPT_DIR}/pre_update_hook.sh" ]; then
  267. bash "${SCRIPT_DIR}/pre_update_hook.sh"
  268. fi
  269. if [[ "$(uname -r)" =~ ^4\.15\.0-60 ]]; then
  270. echo "DO NOT RUN mailcow ON THIS UBUNTU KERNEL!";
  271. echo "Please update to 5.x or use another distribution."
  272. exit 1
  273. fi
  274. if [[ "$(uname -r)" =~ ^4\.4\. ]]; then
  275. if grep -q Ubuntu <<< $(uname -a); then
  276. echo "DO NOT RUN mailcow ON THIS UBUNTU KERNEL!"
  277. echo "Please update to linux-generic-hwe-16.04 by running \"apt-get install --install-recommends linux-generic-hwe-16.04\""
  278. exit 1
  279. fi
  280. echo "mailcow on a 4.4.x kernel is not supported. It may or may not work, please upgrade your kernel or continue at your own risk."
  281. read -p "Press any key to continue..." < /dev/tty
  282. fi
  283. # Exit on error and pipefail
  284. set -o pipefail
  285. # Setting high dc timeout
  286. export COMPOSE_HTTP_TIMEOUT=600
  287. # Add /opt/bin to PATH
  288. PATH=$PATH:/opt/bin
  289. umask 0022
  290. # Unset COMPOSE_COMMAND and DOCKER_COMPOSE_VERSION Variable to be on the newest state.
  291. unset COMPOSE_COMMAND
  292. unset DOCKER_COMPOSE_VERSION
  293. for bin in curl docker git awk sha1sum grep cut; do
  294. if [[ -z $(command -v ${bin}) ]]; then
  295. echo "Cannot find ${bin}, exiting..."
  296. exit 1;
  297. fi
  298. done
  299. export LC_ALL=C
  300. DATE=$(date +%Y-%m-%d_%H_%M_%S)
  301. BRANCH=$(cd ${SCRIPT_DIR}; git rev-parse --abbrev-ref HEAD)
  302. while (($#)); do
  303. case "${1}" in
  304. --check|-c)
  305. echo "Checking remote code for updates..."
  306. LATEST_REV=$(git ls-remote --exit-code --refs --quiet https://github.com/mailcow/mailcow-dockerized ${BRANCH} | cut -f1)
  307. if [ $? -ne 0 ]; then
  308. echo "A problem occurred while trying to fetch the latest revision from github."
  309. exit 99
  310. fi
  311. if [[ -z $(git log HEAD --pretty=format:"%H" | grep "${LATEST_REV}") ]]; then
  312. echo -e "Updated code is available.\nThe changes can be found here: https://github.com/mailcow/mailcow-dockerized/commits/master"
  313. git log --date=short --pretty=format:"%ad - %s" $(git rev-parse --short HEAD)..origin/master
  314. exit 0
  315. else
  316. echo "No updates available."
  317. exit 3
  318. fi
  319. ;;
  320. --ours)
  321. MERGE_STRATEGY=ours
  322. ;;
  323. --skip-start)
  324. SKIP_START=y
  325. ;;
  326. --skip-ping-check)
  327. SKIP_PING_CHECK=y
  328. ;;
  329. --stable)
  330. CURRENT_BRANCH="$(cd ${SCRIPT_DIR}; git rev-parse --abbrev-ref HEAD)"
  331. NEW_BRANCH="master"
  332. ;;
  333. --gc)
  334. echo -e "\e[32mCollecting garbage...\e[0m"
  335. docker_garbage
  336. exit 0
  337. ;;
  338. --nightly)
  339. CURRENT_BRANCH="$(cd ${SCRIPT_DIR}; git rev-parse --abbrev-ref HEAD)"
  340. NEW_BRANCH="nightly"
  341. ;;
  342. --prefetch)
  343. echo -e "\e[32mPrefetching images...\e[0m"
  344. prefetch_images
  345. exit 0
  346. ;;
  347. -f|--force)
  348. echo -e "\e[32mRunning in forced mode...\e[0m"
  349. FORCE=y
  350. ;;
  351. -d|--dev)
  352. echo -e "\e[32mRunning in Developer mode...\e[0m"
  353. DEV=y
  354. ;;
  355. --help|-h)
  356. echo './update.sh [-c|--check, --ours, --gc, --nightly, --prefetch, --skip-start, --skip-ping-check, --stable, -f|--force, -d|--dev, -h|--help]
  357. -c|--check - Check for updates and exit (exit codes => 0: update available, 3: no updates)
  358. --ours - Use merge strategy option "ours" to solve conflicts in favor of non-mailcow code (local changes over remote changes), not recommended!
  359. --gc - Run garbage collector to delete old image tags
  360. --nightly - Switch your mailcow updates to the unstable (nightly) branch. FOR TESTING PURPOSES ONLY!!!!
  361. --prefetch - Only prefetch new images and exit (useful to prepare updates)
  362. --skip-start - Do not start mailcow after update
  363. --skip-ping-check - Skip ICMP Check to public DNS resolvers (Use it only if you´ve blocked any ICMP Connections to your mailcow machine)
  364. --stable - Switch your mailcow updates to the stable (master) branch. Default unless you changed it with --nightly.
  365. -f|--force - Force update, do not ask questions
  366. -d|--dev - Enables Developer Mode (No Checkout of update.sh for tests)
  367. '
  368. exit 1
  369. esac
  370. shift
  371. done
  372. chmod 600 mailcow.conf
  373. source mailcow.conf
  374. detect_docker_compose_command
  375. [[ ! -f mailcow.conf ]] && { echo "mailcow.conf is missing! Is mailcow installed?"; exit 1;}
  376. DOTS=${MAILCOW_HOSTNAME//[^.]};
  377. if [ ${#DOTS} -lt 1 ]; then
  378. echo -e "\e[31mMAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) is not a FQDN!\e[0m"
  379. sleep 1
  380. echo "Please change it to a FQDN and redeploy the stack with $COMPOSE_COMMAND up -d"
  381. exit 1
  382. elif [[ "${MAILCOW_HOSTNAME: -1}" == "." ]]; then
  383. echo "MAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) is ending with a dot. This is not a valid FQDN!"
  384. exit 1
  385. elif [ ${#DOTS} -eq 1 ]; then
  386. echo -e "\e[33mMAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) does not contain a Subdomain. This is not fully tested and may cause issues.\e[0m"
  387. echo "Find more information about why this message exists here: https://github.com/mailcow/mailcow-dockerized/issues/1572"
  388. read -r -p "Do you want to proceed anyway? [y/N] " response
  389. if [[ "$response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  390. echo "OK. Procceding."
  391. else
  392. echo "OK. Exiting."
  393. exit 1
  394. fi
  395. fi
  396. if grep --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox grep detected, please install gnu grep, \"apk add --no-cache --upgrade grep\""; exit 1; fi
  397. # This will also cover sort
  398. if cp --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox cp detected, please install coreutils, \"apk add --no-cache --upgrade coreutils\""; exit 1; fi
  399. if sed --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox sed detected, please install gnu sed, \"apk add --no-cache --upgrade sed\""; exit 1; fi
  400. CONFIG_ARRAY=(
  401. "SKIP_LETS_ENCRYPT"
  402. "SKIP_SOGO"
  403. "USE_WATCHDOG"
  404. "WATCHDOG_NOTIFY_EMAIL"
  405. "WATCHDOG_NOTIFY_BAN"
  406. "WATCHDOG_EXTERNAL_CHECKS"
  407. "WATCHDOG_SUBJECT"
  408. "SKIP_CLAMD"
  409. "SKIP_IP_CHECK"
  410. "ADDITIONAL_SAN"
  411. "DOVEADM_PORT"
  412. "IPV4_NETWORK"
  413. "IPV6_NETWORK"
  414. "LOG_LINES"
  415. "SNAT_TO_SOURCE"
  416. "SNAT6_TO_SOURCE"
  417. "COMPOSE_PROJECT_NAME"
  418. "DOCKER_COMPOSE_VERSION"
  419. "SQL_PORT"
  420. "API_KEY"
  421. "API_KEY_READ_ONLY"
  422. "API_ALLOW_FROM"
  423. "MAILDIR_GC_TIME"
  424. "MAILDIR_SUB"
  425. "ACL_ANYONE"
  426. "SOLR_HEAP"
  427. "SKIP_SOLR"
  428. "ENABLE_SSL_SNI"
  429. "ALLOW_ADMIN_EMAIL_LOGIN"
  430. "SKIP_HTTP_VERIFICATION"
  431. "SOGO_EXPIRE_SESSION"
  432. "REDIS_PORT"
  433. "DOVECOT_MASTER_USER"
  434. "DOVECOT_MASTER_PASS"
  435. "MAILCOW_PASS_SCHEME"
  436. "ADDITIONAL_SERVER_NAMES"
  437. "ACME_CONTACT"
  438. "WATCHDOG_VERBOSE"
  439. "WEBAUTHN_ONLY_TRUSTED_VENDORS"
  440. "SPAMHAUS_DQS_KEY"
  441. )
  442. detect_bad_asn
  443. sed -i --follow-symlinks '$a\' mailcow.conf
  444. for option in ${CONFIG_ARRAY[@]}; do
  445. if [[ ${option} == "ADDITIONAL_SAN" ]]; then
  446. if ! grep -q ${option} mailcow.conf; then
  447. echo "Adding new option \"${option}\" to mailcow.conf"
  448. echo "${option}=" >> mailcow.conf
  449. fi
  450. elif [[ ${option} == "COMPOSE_PROJECT_NAME" ]]; then
  451. if ! grep -q ${option} mailcow.conf; then
  452. echo "Adding new option \"${option}\" to mailcow.conf"
  453. echo "COMPOSE_PROJECT_NAME=mailcowdockerized" >> mailcow.conf
  454. fi
  455. elif [[ ${option} == "DOCKER_COMPOSE_VERSION" ]]; then
  456. if ! grep -q ${option} mailcow.conf; then
  457. echo "Adding new option \"${option}\" to mailcow.conf"
  458. echo "# Used Docker Compose version" >> mailcow.conf
  459. echo "# Switch here between native (compose plugin) and standalone" >> mailcow.conf
  460. echo "# For more informations take a look at the mailcow docs regarding the configuration options." >> mailcow.conf
  461. echo "# Normally this should be untouched but if you decided to use either of those you can switch it manually here." >> mailcow.conf
  462. echo "# Please be aware that at least one of those variants should be installed on your maschine or mailcow will fail." >> mailcow.conf
  463. echo "" >> mailcow.conf
  464. echo "DOCKER_COMPOSE_VERSION=${DOCKER_COMPOSE_VERSION}" >> mailcow.conf
  465. fi
  466. elif [[ ${option} == "DOVEADM_PORT" ]]; then
  467. if ! grep -q ${option} mailcow.conf; then
  468. echo "Adding new option \"${option}\" to mailcow.conf"
  469. echo "DOVEADM_PORT=127.0.0.1:19991" >> mailcow.conf
  470. fi
  471. elif [[ ${option} == "WATCHDOG_NOTIFY_EMAIL" ]]; then
  472. if ! grep -q ${option} mailcow.conf; then
  473. echo "Adding new option \"${option}\" to mailcow.conf"
  474. echo "WATCHDOG_NOTIFY_EMAIL=" >> mailcow.conf
  475. fi
  476. elif [[ ${option} == "LOG_LINES" ]]; then
  477. if ! grep -q ${option} mailcow.conf; then
  478. echo "Adding new option \"${option}\" to mailcow.conf"
  479. echo '# Max log lines per service to keep in Redis logs' >> mailcow.conf
  480. echo "LOG_LINES=9999" >> mailcow.conf
  481. fi
  482. elif [[ ${option} == "IPV4_NETWORK" ]]; then
  483. if ! grep -q ${option} mailcow.conf; then
  484. echo "Adding new option \"${option}\" to mailcow.conf"
  485. echo '# Internal IPv4 /24 subnet, format n.n.n. (expands to n.n.n.0/24)' >> mailcow.conf
  486. echo "IPV4_NETWORK=172.22.1" >> mailcow.conf
  487. fi
  488. elif [[ ${option} == "IPV6_NETWORK" ]]; then
  489. if ! grep -q ${option} mailcow.conf; then
  490. echo "Adding new option \"${option}\" to mailcow.conf"
  491. echo '# Internal IPv6 subnet in fc00::/7' >> mailcow.conf
  492. echo "IPV6_NETWORK=fd4d:6169:6c63:6f77::/64" >> mailcow.conf
  493. fi
  494. elif [[ ${option} == "SQL_PORT" ]]; then
  495. if ! grep -q ${option} mailcow.conf; then
  496. echo "Adding new option \"${option}\" to mailcow.conf"
  497. echo '# Bind SQL to 127.0.0.1 on port 13306' >> mailcow.conf
  498. echo "SQL_PORT=127.0.0.1:13306" >> mailcow.conf
  499. fi
  500. elif [[ ${option} == "API_KEY" ]]; then
  501. if ! grep -q ${option} mailcow.conf; then
  502. echo "Adding new option \"${option}\" to mailcow.conf"
  503. echo '# Create or override API key for web UI' >> mailcow.conf
  504. echo "#API_KEY=" >> mailcow.conf
  505. fi
  506. elif [[ ${option} == "API_KEY_READ_ONLY" ]]; then
  507. if ! grep -q ${option} mailcow.conf; then
  508. echo "Adding new option \"${option}\" to mailcow.conf"
  509. echo '# Create or override read-only API key for web UI' >> mailcow.conf
  510. echo "#API_KEY_READ_ONLY=" >> mailcow.conf
  511. fi
  512. elif [[ ${option} == "API_ALLOW_FROM" ]]; then
  513. if ! grep -q ${option} mailcow.conf; then
  514. echo "Adding new option \"${option}\" to mailcow.conf"
  515. echo '# Must be set for API_KEY to be active' >> mailcow.conf
  516. echo '# IPs only, no networks (networks can be set via UI)' >> mailcow.conf
  517. echo "#API_ALLOW_FROM=" >> mailcow.conf
  518. fi
  519. elif [[ ${option} == "SNAT_TO_SOURCE" ]]; then
  520. if ! grep -q ${option} mailcow.conf; then
  521. echo "Adding new option \"${option}\" to mailcow.conf"
  522. echo '# Use this IPv4 for outgoing connections (SNAT)' >> mailcow.conf
  523. echo "#SNAT_TO_SOURCE=" >> mailcow.conf
  524. fi
  525. elif [[ ${option} == "SNAT6_TO_SOURCE" ]]; then
  526. if ! grep -q ${option} mailcow.conf; then
  527. echo "Adding new option \"${option}\" to mailcow.conf"
  528. echo '# Use this IPv6 for outgoing connections (SNAT)' >> mailcow.conf
  529. echo "#SNAT6_TO_SOURCE=" >> mailcow.conf
  530. fi
  531. elif [[ ${option} == "MAILDIR_GC_TIME" ]]; then
  532. if ! grep -q ${option} mailcow.conf; then
  533. echo "Adding new option \"${option}\" to mailcow.conf"
  534. echo '# Garbage collector cleanup' >> mailcow.conf
  535. echo '# Deleted domains and mailboxes are moved to /var/vmail/_garbage/timestamp_sanitizedstring' >> mailcow.conf
  536. echo '# How long should objects remain in the garbage until they are being deleted? (value in minutes)' >> mailcow.conf
  537. echo '# Check interval is hourly' >> mailcow.conf
  538. echo 'MAILDIR_GC_TIME=1440' >> mailcow.conf
  539. fi
  540. elif [[ ${option} == "ACL_ANYONE" ]]; then
  541. if ! grep -q ${option} mailcow.conf; then
  542. echo "Adding new option \"${option}\" to mailcow.conf"
  543. echo '# Set this to "allow" to enable the anyone pseudo user. Disabled by default.' >> mailcow.conf
  544. echo '# When enabled, ACL can be created, that apply to "All authenticated users"' >> mailcow.conf
  545. echo '# This should probably only be activated on mail hosts, that are used exclusivly by one organisation.' >> mailcow.conf
  546. echo '# Otherwise a user might share data with too many other users.' >> mailcow.conf
  547. echo 'ACL_ANYONE=disallow' >> mailcow.conf
  548. fi
  549. elif [[ ${option} == "SOLR_HEAP" ]]; then
  550. if ! grep -q ${option} mailcow.conf; then
  551. echo "Adding new option \"${option}\" to mailcow.conf"
  552. echo '# Solr heap size, there is no recommendation, please see Solr docs.' >> mailcow.conf
  553. echo '# Solr is a prone to run OOM on large systems and should be monitored. Unmonitored Solr setups are not recommended.' >> mailcow.conf
  554. echo '# Solr will refuse to start with total system memory below or equal to 2 GB.' >> mailcow.conf
  555. echo "SOLR_HEAP=1024" >> mailcow.conf
  556. fi
  557. elif [[ ${option} == "SKIP_SOLR" ]]; then
  558. if ! grep -q ${option} mailcow.conf; then
  559. echo "Adding new option \"${option}\" to mailcow.conf"
  560. echo '# Solr is disabled by default after upgrading from non-Solr to Solr-enabled mailcows.' >> mailcow.conf
  561. echo '# Disable Solr or if you do not want to store a readable index of your mails in solr-vol-1.' >> mailcow.conf
  562. echo "SKIP_SOLR=y" >> mailcow.conf
  563. fi
  564. elif [[ ${option} == "ENABLE_SSL_SNI" ]]; then
  565. if ! grep -q ${option} mailcow.conf; then
  566. echo "Adding new option \"${option}\" to mailcow.conf"
  567. echo '# Create seperate certificates for all domains - y/n' >> mailcow.conf
  568. echo '# this will allow adding more than 100 domains, but some email clients will not be able to connect with alternative hostnames' >> mailcow.conf
  569. echo '# see https://wiki.dovecot.org/SSL/SNIClientSupport' >> mailcow.conf
  570. echo "ENABLE_SSL_SNI=n" >> mailcow.conf
  571. fi
  572. elif [[ ${option} == "SKIP_SOGO" ]]; then
  573. if ! grep -q ${option} mailcow.conf; then
  574. echo "Adding new option \"${option}\" to mailcow.conf"
  575. echo '# Skip SOGo: Will disable SOGo integration and therefore webmail, DAV protocols and ActiveSync support (experimental, unsupported, not fully implemented) - y/n' >> mailcow.conf
  576. echo "SKIP_SOGO=n" >> mailcow.conf
  577. fi
  578. elif [[ ${option} == "MAILDIR_SUB" ]]; then
  579. if ! grep -q ${option} mailcow.conf; then
  580. echo "Adding new option \"${option}\" to mailcow.conf"
  581. echo '# MAILDIR_SUB defines a path in a users virtual home to keep the maildir in. Leave empty for updated setups.' >> mailcow.conf
  582. echo "#MAILDIR_SUB=Maildir" >> mailcow.conf
  583. echo "MAILDIR_SUB=" >> mailcow.conf
  584. fi
  585. elif [[ ${option} == "WATCHDOG_NOTIFY_BAN" ]]; then
  586. if ! grep -q ${option} mailcow.conf; then
  587. echo "Adding new option \"${option}\" to mailcow.conf"
  588. echo '# Notify about banned IP. Includes whois lookup.' >> mailcow.conf
  589. echo "WATCHDOG_NOTIFY_BAN=y" >> mailcow.conf
  590. fi
  591. elif [[ ${option} == "WATCHDOG_SUBJECT" ]]; then
  592. if ! grep -q ${option} mailcow.conf; then
  593. echo "Adding new option \"${option}\" to mailcow.conf"
  594. echo '# Subject for watchdog mails. Defaults to "Watchdog ALERT" followed by the error message.' >> mailcow.conf
  595. echo "#WATCHDOG_SUBJECT=" >> mailcow.conf
  596. fi
  597. elif [[ ${option} == "WATCHDOG_EXTERNAL_CHECKS" ]]; then
  598. if ! grep -q ${option} mailcow.conf; then
  599. echo "Adding new option \"${option}\" to mailcow.conf"
  600. echo '# Checks if mailcow is an open relay. Requires a SAL. More checks will follow.' >> mailcow.conf
  601. echo '# No data is collected. Opt-in and anonymous.' >> mailcow.conf
  602. echo '# Will only work with unmodified mailcow setups.' >> mailcow.conf
  603. echo "WATCHDOG_EXTERNAL_CHECKS=n" >> mailcow.conf
  604. fi
  605. elif [[ ${option} == "SOGO_EXPIRE_SESSION" ]]; then
  606. if ! grep -q ${option} mailcow.conf; then
  607. echo "Adding new option \"${option}\" to mailcow.conf"
  608. echo '# SOGo session timeout in minutes' >> mailcow.conf
  609. echo "SOGO_EXPIRE_SESSION=480" >> mailcow.conf
  610. fi
  611. elif [[ ${option} == "REDIS_PORT" ]]; then
  612. if ! grep -q ${option} mailcow.conf; then
  613. echo "Adding new option \"${option}\" to mailcow.conf"
  614. echo "REDIS_PORT=127.0.0.1:7654" >> mailcow.conf
  615. fi
  616. elif [[ ${option} == "DOVECOT_MASTER_USER" ]]; then
  617. if ! grep -q ${option} mailcow.conf; then
  618. echo "Adding new option \"${option}\" to mailcow.conf"
  619. echo '# DOVECOT_MASTER_USER and _PASS must _both_ be provided. No special chars.' >> mailcow.conf
  620. echo '# Empty by default to auto-generate master user and password on start.' >> mailcow.conf
  621. echo '# User expands to DOVECOT_MASTER_USER@mailcow.local' >> mailcow.conf
  622. echo '# LEAVE EMPTY IF UNSURE' >> mailcow.conf
  623. echo "DOVECOT_MASTER_USER=" >> mailcow.conf
  624. fi
  625. elif [[ ${option} == "DOVECOT_MASTER_PASS" ]]; then
  626. if ! grep -q ${option} mailcow.conf; then
  627. echo "Adding new option \"${option}\" to mailcow.conf"
  628. echo '# LEAVE EMPTY IF UNSURE' >> mailcow.conf
  629. echo "DOVECOT_MASTER_PASS=" >> mailcow.conf
  630. fi
  631. elif [[ ${option} == "MAILCOW_PASS_SCHEME" ]]; then
  632. if ! grep -q ${option} mailcow.conf; then
  633. echo "Adding new option \"${option}\" to mailcow.conf"
  634. echo '# Password hash algorithm' >> mailcow.conf
  635. echo '# Only certain password hash algorithm are supported. For a fully list of supported schemes,' >> mailcow.conf
  636. echo '# see https://docs.mailcow.email/models/model-passwd/' >> mailcow.conf
  637. echo "MAILCOW_PASS_SCHEME=BLF-CRYPT" >> mailcow.conf
  638. fi
  639. elif [[ ${option} == "ADDITIONAL_SERVER_NAMES" ]]; then
  640. if ! grep -q ${option} mailcow.conf; then
  641. echo "Adding new option \"${option}\" to mailcow.conf"
  642. echo '# Additional server names for mailcow UI' >> mailcow.conf
  643. echo '#' >> mailcow.conf
  644. echo '# Specify alternative addresses for the mailcow UI to respond to' >> mailcow.conf
  645. echo '# This is useful when you set mail.* as ADDITIONAL_SAN and want to make sure mail.maildomain.com will always point to the mailcow UI.' >> mailcow.conf
  646. echo '# If the server name does not match a known site, Nginx decides by best-guess and may redirect users to the wrong web root.' >> mailcow.conf
  647. echo '# You can understand this as server_name directive in Nginx.' >> mailcow.conf
  648. echo '# Comma separated list without spaces! Example: ADDITIONAL_SERVER_NAMES=a.b.c,d.e.f' >> mailcow.conf
  649. echo 'ADDITIONAL_SERVER_NAMES=' >> mailcow.conf
  650. fi
  651. elif [[ ${option} == "ACME_CONTACT" ]]; then
  652. if ! grep -q ${option} mailcow.conf; then
  653. echo "Adding new option \"${option}\" to mailcow.conf"
  654. echo '# Lets Encrypt registration contact information' >> mailcow.conf
  655. echo '# Optional: Leave empty for none' >> mailcow.conf
  656. echo '# This value is only used on first order!' >> mailcow.conf
  657. echo '# Setting it at a later point will require the following steps:' >> mailcow.conf
  658. echo '# https://docs.mailcow.email/troubleshooting/debug-reset_tls/' >> mailcow.conf
  659. echo 'ACME_CONTACT=' >> mailcow.conf
  660. fi
  661. elif [[ ${option} == "WEBAUTHN_ONLY_TRUSTED_VENDORS" ]]; then
  662. if ! grep -q ${option} mailcow.conf; then
  663. echo "Adding new option \"${option}\" to mailcow.conf"
  664. echo "# WebAuthn device manufacturer verification" >> mailcow.conf
  665. echo '# After setting WEBAUTHN_ONLY_TRUSTED_VENDORS=y only devices from trusted manufacturers are allowed' >> mailcow.conf
  666. echo '# root certificates can be placed for validation under mailcow-dockerized/data/web/inc/lib/WebAuthn/rootCertificates' >> mailcow.conf
  667. echo 'WEBAUTHN_ONLY_TRUSTED_VENDORS=n' >> mailcow.conf
  668. fi
  669. elif [[ ${option} == "SPAMHAUS_DQS_KEY" ]]; then
  670. if ! grep -q ${option} mailcow.conf; then
  671. echo "Adding new option \"${option}\" to mailcow.conf"
  672. echo "# Spamhaus Data Query Service Key" >> mailcow.conf
  673. echo '# Optional: Leave empty for none' >> mailcow.conf
  674. echo '# Enter your key here if you are using a blocked ASN (OVH, AWS, Cloudflare e.g) for the unregistered Spamhaus Blocklist.' >> mailcow.conf
  675. echo '# If empty, it will completely disable Spamhaus blocklists if it detects that you are running on a server using a blocked AS.' >> mailcow.conf
  676. echo '# Otherwise it will work as usual.' >> mailcow.conf
  677. echo 'SPAMHAUS_DQS_KEY=' >> mailcow.conf
  678. fi
  679. elif [[ ${option} == "WATCHDOG_VERBOSE" ]]; then
  680. if ! grep -q ${option} mailcow.conf; then
  681. echo "Adding new option \"${option}\" to mailcow.conf"
  682. echo '# Enable watchdog verbose logging' >> mailcow.conf
  683. echo 'WATCHDOG_VERBOSE=n' >> mailcow.conf
  684. fi
  685. elif ! grep -q ${option} mailcow.conf; then
  686. echo "Adding new option \"${option}\" to mailcow.conf"
  687. echo "${option}=n" >> mailcow.conf
  688. fi
  689. done
  690. if [[( ${SKIP_PING_CHECK} == "y")]]; then
  691. echo -e "\e[32mSkipping Ping Check...\e[0m"
  692. else
  693. echo -en "Checking internet connection... "
  694. if ! check_online_status; then
  695. echo -e "\e[31mfailed\e[0m"
  696. exit 1
  697. else
  698. echo -e "\e[32mOK\e[0m"
  699. fi
  700. fi
  701. if ! [ $NEW_BRANCH ]; then
  702. echo -e "\e[33mDetecting which build your mailcow runs on...\e[0m"
  703. sleep 1
  704. if [ ${BRANCH} == "master" ]; then
  705. echo -e "\e[32mYou are receiving stable updates (master).\e[0m"
  706. echo -e "\e[33mTo change that run the update.sh Script one time with the --nightly parameter to switch to nightly builds.\e[0m"
  707. elif [ ${BRANCH} == "nightly" ]; then
  708. echo -e "\e[31mYou are receiving unstable updates (nightly). These are for testing purposes only!!!\e[0m"
  709. sleep 1
  710. echo -e "\e[33mTo change that run the update.sh Script one time with the --stable parameter to switch to stable builds.\e[0m"
  711. else
  712. echo -e "\e[33mYou are receiving updates from a unsupported branch.\e[0m"
  713. sleep 1
  714. echo -e "\e[33mThe mailcow stack might still work but it is recommended to switch to the master branch (stable builds).\e[0m"
  715. echo -e "\e[33mTo change that run the update.sh Script one time with the --stable parameter to switch to stable builds.\e[0m"
  716. fi
  717. elif [ $FORCE ]; then
  718. echo -e "\e[31mYou are running in forced mode!\e[0m"
  719. echo -e "\e[31mA Branch Switch can only be performed manually (monitored).\e[0m"
  720. echo -e "\e[31mPlease rerun the update.sh Script without the --force/-f parameter.\e[0m"
  721. sleep 1
  722. elif [ $NEW_BRANCH == "master" ] && [ $CURRENT_BRANCH != "master" ]; then
  723. echo -e "\e[33mYou are about to switch your mailcow Updates to the stable (master) branch.\e[0m"
  724. sleep 1
  725. echo -e "\e[33mBefore you do: Please take a backup of all components to ensure that no Data is lost...\e[0m"
  726. sleep 1
  727. echo -e "\e[31mWARNING: Please see on GitHub or ask in the communitys if a switch to master is stable or not.
  728. In some rear cases a Update back to master can destroy your mailcow configuration in case of Database Upgrades etc.
  729. Normally a upgrade back to master should be safe during each full release.
  730. Check GitHub for Database Changes and Update only if there similar to the full release!\e[0m"
  731. read -r -p "Are you sure you that want to continue upgrading to the stable (master) branch? [y/N] " response
  732. if [[ ! "${response}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  733. echo "OK. If you prepared yourself for that please run the update.sh Script with the --stable parameter again to trigger this process here."
  734. exit 0
  735. fi
  736. BRANCH=$NEW_BRANCH
  737. DIFF_DIRECTORY=update_diffs
  738. DIFF_FILE=${DIFF_DIRECTORY}/diff_before_upgrade_to_master_$(date +"%Y-%m-%d-%H-%M-%S")
  739. mv diff_before_upgrade* ${DIFF_DIRECTORY}/ 2> /dev/null
  740. if ! git diff-index --quiet HEAD; then
  741. echo -e "\e[32mSaving diff to ${DIFF_FILE}...\e[0m"
  742. mkdir -p ${DIFF_DIRECTORY}
  743. git diff ${BRANCH} --stat > ${DIFF_FILE}
  744. git diff ${BRANCH} >> ${DIFF_FILE}
  745. fi
  746. echo -e "\e[32mSwitching Branch to ${BRANCH}...\e[0m"
  747. git fetch origin
  748. git checkout -f ${BRANCH}
  749. elif [ $NEW_BRANCH == "nightly" ] && [ $CURRENT_BRANCH != "nightly" ]; then
  750. echo -e "\e[33mYou are about to switch your mailcow Updates to the unstable (nightly) branch.\e[0m"
  751. sleep 1
  752. echo -e "\e[33mBefore you do: Please take a backup of all components to ensure that no Data is lost...\e[0m"
  753. sleep 1
  754. echo -e "\e[31mWARNING: A switch to nightly is possible any time. But a switch back (to master) isn't.\e[0m"
  755. read -r -p "Are you sure you that want to continue upgrading to the unstable (nightly) branch? [y/N] " response
  756. if [[ ! "${response}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  757. echo "OK. If you prepared yourself for that please run the update.sh Script with the --nightly parameter again to trigger this process here."
  758. exit 0
  759. fi
  760. BRANCH=$NEW_BRANCH
  761. DIFF_DIRECTORY=update_diffs
  762. DIFF_FILE=${DIFF_DIRECTORY}/diff_before_upgrade_to_nightly_$(date +"%Y-%m-%d-%H-%M-%S")
  763. mv diff_before_upgrade* ${DIFF_DIRECTORY}/ 2> /dev/null
  764. if ! git diff-index --quiet HEAD; then
  765. echo -e "\e[32mSaving diff to ${DIFF_FILE}...\e[0m"
  766. mkdir -p ${DIFF_DIRECTORY}
  767. git diff ${BRANCH} --stat > ${DIFF_FILE}
  768. git diff ${BRANCH} >> ${DIFF_FILE}
  769. fi
  770. git fetch origin
  771. git checkout -f ${BRANCH}
  772. fi
  773. if [ ! $DEV ]; then
  774. echo -e "\e[32mChecking for newer update script...\e[0m"
  775. SHA1_1=$(sha1sum update.sh)
  776. git fetch origin #${BRANCH}
  777. git checkout origin/${BRANCH} update.sh
  778. SHA1_2=$(sha1sum update.sh)
  779. if [[ ${SHA1_1} != ${SHA1_2} ]]; then
  780. echo "update.sh changed, please run this script again, exiting."
  781. chmod +x update.sh
  782. exit 2
  783. fi
  784. fi
  785. if [ ! $FORCE ]; then
  786. read -r -p "Are you sure you want to update mailcow: dockerized? All containers will be stopped. [y/N] " response
  787. if [[ ! "${response}" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  788. echo "OK, exiting."
  789. exit 0
  790. fi
  791. migrate_docker_nat
  792. fi
  793. remove_obsolete_nginx_ports
  794. echo -e "\e[32mValidating docker-compose stack configuration...\e[0m"
  795. sed -i 's/HTTPS_BIND:-:/HTTPS_BIND:-/g' docker-compose.yml
  796. sed -i 's/HTTP_BIND:-:/HTTP_BIND:-/g' docker-compose.yml
  797. if ! $COMPOSE_COMMAND config -q; then
  798. echo -e "\e[31m\nOh no, something went wrong. Please check the error message above.\e[0m"
  799. exit 1
  800. fi
  801. echo -e "\e[32mChecking for conflicting bridges...\e[0m"
  802. MAILCOW_BRIDGE=$($COMPOSE_COMMAND config | grep -i com.docker.network.bridge.name | cut -d':' -f2)
  803. while read NAT_ID; do
  804. iptables -t nat -D POSTROUTING $NAT_ID
  805. done < <(iptables -L -vn -t nat --line-numbers | grep $IPV4_NETWORK | grep -E 'MASQUERADE.*all' | grep -v ${MAILCOW_BRIDGE} | cut -d' ' -f1)
  806. DIFF_DIRECTORY=update_diffs
  807. DIFF_FILE=${DIFF_DIRECTORY}/diff_before_update_$(date +"%Y-%m-%d-%H-%M-%S")
  808. mv diff_before_update* ${DIFF_DIRECTORY}/ 2> /dev/null
  809. if ! git diff-index --quiet HEAD; then
  810. echo -e "\e[32mSaving diff to ${DIFF_FILE}...\e[0m"
  811. mkdir -p ${DIFF_DIRECTORY}
  812. git diff --stat > ${DIFF_FILE}
  813. git diff >> ${DIFF_FILE}
  814. fi
  815. echo -e "\e[32mPrefetching images...\e[0m"
  816. prefetch_images
  817. echo -e "\e[32mStopping mailcow...\e[0m"
  818. sleep 2
  819. MAILCOW_CONTAINERS=($($COMPOSE_COMMAND ps -q))
  820. $COMPOSE_COMMAND down
  821. echo -e "\e[32mChecking for remaining containers...\e[0m"
  822. sleep 2
  823. for container in "${MAILCOW_CONTAINERS[@]}"; do
  824. docker rm -f "$container" 2> /dev/null
  825. done
  826. [[ -f data/conf/nginx/ZZZ-ejabberd.conf ]] && rm data/conf/nginx/ZZZ-ejabberd.conf
  827. # Silently fixing remote url from andryyy to mailcow
  828. # git remote set-url origin https://github.com/mailcow/mailcow-dockerized
  829. DEFAULT_REPO=https://github.com/mailcow/mailcow-dockerized
  830. CURRENT_REPO=$(git remote get-url origin)
  831. if [ "$CURRENT_REPO" != "$DEFAULT_REPO" ]; then
  832. echo "The Repository currently used is not the default Mailcow Repository."
  833. echo "Currently Repository: $CURRENT_REPO"
  834. echo "Default Repository: $DEFAULT_REPO"
  835. read -r -p "Should it be changed back to default? [y/N] " repo_response
  836. if [[ "$repo_response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  837. git remote set-url origin $DEFAULT_REPO
  838. fi
  839. fi
  840. if [ ! $DEV ]; then
  841. echo -e "\e[32mCommitting current status...\e[0m"
  842. [[ -z "$(git config user.name)" ]] && git config user.name moo
  843. [[ -z "$(git config user.email)" ]] && git config user.email moo@cow.moo
  844. [[ ! -z $(git ls-files data/conf/rspamd/override.d/worker-controller-password.inc) ]] && git rm data/conf/rspamd/override.d/worker-controller-password.inc
  845. git add -u
  846. git commit -am "Before update on ${DATE}" > /dev/null
  847. echo -e "\e[32mFetching updated code from remote...\e[0m"
  848. git fetch origin #${BRANCH}
  849. echo -e "\e[32mMerging local with remote code (recursive, strategy: \"${MERGE_STRATEGY:-theirs}\", options: \"patience\"...\e[0m"
  850. git config merge.defaultToUpstream true
  851. git merge -X${MERGE_STRATEGY:-theirs} -Xpatience -m "After update on ${DATE}"
  852. # Need to use a variable to not pass return codes of if checks
  853. MERGE_RETURN=$?
  854. if [[ ${MERGE_RETURN} == 128 ]]; then
  855. echo -e "\e[31m\nOh no, what happened?\n=> You most likely added files to your local mailcow instance that were now added to the official mailcow repository. Please move them to another location before updating mailcow.\e[0m"
  856. exit 1
  857. elif [[ ${MERGE_RETURN} == 1 ]]; then
  858. echo -e "\e[93mPotenial conflict, trying to fix...\e[0m"
  859. git status --porcelain | grep -E "UD|DU" | awk '{print $2}' | xargs rm -v
  860. git add -A
  861. git commit -m "After update on ${DATE}" > /dev/null
  862. git checkout .
  863. echo -e "\e[32mRemoved and recreated files if necessary.\e[0m"
  864. elif [[ ${MERGE_RETURN} != 0 ]]; then
  865. echo -e "\e[31m\nOh no, something went wrong. Please check the error message above.\e[0m"
  866. echo
  867. echo "Run $COMPOSE_COMMAND up -d to restart your stack without updates or try again after fixing the mentioned errors."
  868. exit 1
  869. fi
  870. elif [ $DEV ]; then
  871. echo -e "\e[33mDEVELOPER MODE: Not creating a git diff and commiting it to prevent development stuff within a backup diff...\e[0m"
  872. fi
  873. echo -e "\e[32mFetching new images, if any...\e[0m"
  874. sleep 2
  875. $COMPOSE_COMMAND pull
  876. # Fix missing SSL, does not overwrite existing files
  877. [[ ! -d data/assets/ssl ]] && mkdir -p data/assets/ssl
  878. cp -n -d data/assets/ssl-example/*.pem data/assets/ssl/
  879. echo -e "Checking IPv6 settings... "
  880. if grep -q 'SYSCTL_IPV6_DISABLED=1' mailcow.conf; then
  881. echo
  882. echo '!! IMPORTANT !!'
  883. echo
  884. echo 'SYSCTL_IPV6_DISABLED was removed due to complications. IPv6 can be disabled by editing "docker-compose.yml" and setting "enable_ipv6: true" to "enable_ipv6: false".'
  885. echo "This setting will only be active after a complete shutdown of mailcow by running $COMPOSE_COMMAND down followed by $COMPOSE_COMMAND up -d."
  886. echo
  887. echo '!! IMPORTANT !!'
  888. echo
  889. read -p "Press any key to continue..." < /dev/tty
  890. fi
  891. # Checking for old project name bug
  892. sed -i --follow-symlinks 's#COMPOSEPROJECT_NAME#COMPOSE_PROJECT_NAME#g' mailcow.conf
  893. # Fix Rspamd maps
  894. if [ -f data/conf/rspamd/custom/global_from_blacklist.map ]; then
  895. mv data/conf/rspamd/custom/global_from_blacklist.map data/conf/rspamd/custom/global_smtp_from_blacklist.map
  896. fi
  897. if [ -f data/conf/rspamd/custom/global_from_whitelist.map ]; then
  898. mv data/conf/rspamd/custom/global_from_whitelist.map data/conf/rspamd/custom/global_smtp_from_whitelist.map
  899. fi
  900. # Fix deprecated metrics.conf
  901. if [ -f "data/conf/rspamd/local.d/metrics.conf" ]; then
  902. if [ ! -z "$(git diff --name-only origin/master data/conf/rspamd/local.d/metrics.conf)" ]; then
  903. echo -e "\e[33mWARNING\e[0m - Please migrate your customizations of data/conf/rspamd/local.d/metrics.conf to actions.conf and groups.conf after this update."
  904. echo "The deprecated configuration file metrics.conf will be moved to metrics.conf_deprecated after updating mailcow."
  905. fi
  906. mv data/conf/rspamd/local.d/metrics.conf data/conf/rspamd/local.d/metrics.conf_deprecated
  907. fi
  908. # Set app_info.inc.php
  909. if [ ${BRANCH} == "master" ]; then
  910. mailcow_git_version=$(git describe --tags `git rev-list --tags --max-count=1`)
  911. elif [ ${BRANCH} == "nightly" ]; then
  912. mailcow_git_version=$(git rev-parse --short $(git rev-parse @{upstream}))
  913. mailcow_last_git_version=""
  914. else
  915. mailcow_git_version=$(git rev-parse --short HEAD)
  916. mailcow_last_git_version=""
  917. fi
  918. mailcow_git_commit=$(git rev-parse origin/${BRANCH})
  919. mailcow_git_commit_date=$(git log -1 --format=%ci @{upstream} )
  920. if [ $? -eq 0 ]; then
  921. echo '<?php' > data/web/inc/app_info.inc.php
  922. echo ' $MAILCOW_GIT_VERSION="'$mailcow_git_version'";' >> data/web/inc/app_info.inc.php
  923. echo ' $MAILCOW_LAST_GIT_VERSION="";' >> data/web/inc/app_info.inc.php
  924. echo ' $MAILCOW_GIT_OWNER="mailcow";' >> data/web/inc/app_info.inc.php
  925. echo ' $MAILCOW_GIT_REPO="mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  926. echo ' $MAILCOW_GIT_URL="https://github.com/mailcow/mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  927. echo ' $MAILCOW_GIT_COMMIT="'$mailcow_git_commit'";' >> data/web/inc/app_info.inc.php
  928. echo ' $MAILCOW_GIT_COMMIT_DATE="'$mailcow_git_commit_date'";' >> data/web/inc/app_info.inc.php
  929. echo ' $MAILCOW_BRANCH="'$BRANCH'";' >> data/web/inc/app_info.inc.php
  930. echo ' $MAILCOW_UPDATEDAT='$(date +%s)';' >> data/web/inc/app_info.inc.php
  931. echo '?>' >> data/web/inc/app_info.inc.php
  932. else
  933. echo '<?php' > data/web/inc/app_info.inc.php
  934. echo ' $MAILCOW_GIT_VERSION="'$mailcow_git_version'";' >> data/web/inc/app_info.inc.php
  935. echo ' $MAILCOW_LAST_GIT_VERSION="";' >> data/web/inc/app_info.inc.php
  936. echo ' $MAILCOW_GIT_OWNER="mailcow";' >> data/web/inc/app_info.inc.php
  937. echo ' $MAILCOW_GIT_REPO="mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  938. echo ' $MAILCOW_GIT_URL="https://github.com/mailcow/mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  939. echo ' $MAILCOW_GIT_COMMIT="";' >> data/web/inc/app_info.inc.php
  940. echo ' $MAILCOW_GIT_COMMIT_DATE="";' >> data/web/inc/app_info.inc.php
  941. echo ' $MAILCOW_BRANCH="'$BRANCH'";' >> data/web/inc/app_info.inc.php
  942. echo ' $MAILCOW_UPDATEDAT='$(date +%s)';' >> data/web/inc/app_info.inc.php
  943. echo '?>' >> data/web/inc/app_info.inc.php
  944. echo -e "\e[33mCannot determine current git repository version...\e[0m"
  945. fi
  946. if [[ ${SKIP_START} == "y" ]]; then
  947. echo -e "\e[33mNot starting mailcow, please run \"$COMPOSE_COMMAND up -d --remove-orphans\" to start mailcow.\e[0m"
  948. else
  949. echo -e "\e[32mStarting mailcow...\e[0m"
  950. sleep 2
  951. $COMPOSE_COMMAND up -d --remove-orphans
  952. fi
  953. echo -e "\e[32mCollecting garbage...\e[0m"
  954. docker_garbage
  955. # Run post-update-hook
  956. if [ -f "${SCRIPT_DIR}/post_update_hook.sh" ]; then
  957. bash "${SCRIPT_DIR}/post_update_hook.sh"
  958. fi
  959. # echo "In case you encounter any problem, hard-reset to a state before updating mailcow:"
  960. # echo
  961. # git reflog --color=always | grep "Before update on "
  962. # echo
  963. # echo "Use \"git reset --hard hash-on-the-left\" and run $COMPOSE_COMMAND up -d afterwards."